/* JavaBall Sampler
	for use with Live3D JAVA API
	(c) 1996, Netscape Communications, Inc.
*/

import l3d.*;
import java.awt.*;
import java.applet.Applet;
import netscape.javascript.JSObject;

public class javaball extends Applet implements Runnable {

   	JSObject document;
	L3DScene l3d;
	L3DObject ballObject;

    float ff[] = new float[16] ;
    int y = 0 ;
    float fTemp = 0.0f;
    float fHeight = 0.0f; 

    Thread ballThread;


    public void init() {

	// Make the java applet a black dot
		setBackground(Color.black);

	// Main Initialization
		document = getDocument();
		l3d = (L3DScene)document.getMember("l3d");
		System.out.println(l3d);

	// Object Initialization
		while(ballObject==null) {
			ballObject = l3d.getObject("Ball");
		}
	 
	}

    public void start() {
		if (ballThread == null) {
		    ballThread = new Thread(this);
		    ballThread.start();
		}

     // Create the base matrix array to apply to the ball
        ff[0]=   1.0f;
        ff[1]=   0.0f;
        ff[2]=   0.0f;
        ff[3]=   0.0f;
        ff[4]=   0.0f;
        ff[5]=   1.0f;
        ff[6]=   0.0f;
        ff[7]=   0.0f;
        ff[8]=   0.0f;
        ff[9]=   0.0f;
        ff[10]=  1.0f;
        ff[11]=  0.0f;
        ff[12]=  0.0f;
        ff[13]=  0.0f;
        ff[14]=  0.0f;
        ff[15]=  1.0f;
	}

    public void run() {
		while (ballThread != null) {
 
	    fHeight = 0.0f;
       
	  // The upward flight of the ball
	    for (y = 1; y <= 40; y++)
	      { fTemp = (float) y ;
	        fHeight = fHeight + (2.0f/fTemp);
	        ff[13] = fHeight; 
	        if (y>0) {
		        ff[0] = 1f;
	            ff[5] = 1f;
	            ff[10] = 1f;
            }
                ballObject.transform(ff, 2) ;
    	        l3d.render() ;
	        }

	  // Pause at the apogee
			    try {
				ballThread.sleep(100);
			    } catch (InterruptedException e){
			    }

    
	  // Downward flight of the ball and the squeeze at the bottom
	    for (y = 40; y > 0; y--) {
	            fTemp = (float)y;  
	            fHeight = fHeight - (2.0f/fTemp);
	            ff[13] = fHeight ; 

	        if (y==1)
	            { ff[0] = 1.2f;
	              ff[5] = .8f;
	              ff[10] = 1.2f;
	            }

	        if (y>1)
	            { ff[0] = 1f;
	              ff[5] = 1f;
	              ff[10] = 1f;
	            }
                ballObject.transform(ff, 2) ;
    	        l3d.render();
	        }

	  // Pause at the bottom
			    try {
				ballThread.sleep(100);
			    } catch (InterruptedException e){
			    }
	
		}  
	}

/**********************************************************************
// stop method 
***********************************************************************/

    public void stop() {
	ballThread.stop();
	ballThread = null;
    }

	public JSObject getDocument() {
		return (JSObject)JSObject.getWindow(this).getMember("document");
	}

}

